package com.mobai.mq.rabbitmq.cofig;

import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.DirectExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @ClassName RabbitConfig
 * @Description 描述
 * @Author Mobai
 * @Date 2024/5/31 21:47
 */
@Configuration
public class RabbitConfig {

    @Bean
    public Queue initQueue(){
        return new Queue("create.topic",true);
    }

    /**
     * 创建主题队列
     * @return
     */
    @Bean
    public DirectExchange direct() {
        return new DirectExchange("mobai-mq");
    }

    /**
     * 绑定交换机
     * @param direct
     * @param initQueue
     * @return
     */
    @Bean
    public Binding binding1a(DirectExchange direct,
                             Queue initQueue) {
        return BindingBuilder.bind(initQueue)
                .to(direct)
                .with("mobai-mq");
    }
}
