package com.mobai.runner;

import com.alibaba.fastjson.JSON;
import com.aliyun.ecs20140526.models.DescribeInstancesResponse;
import com.mobai.domain.MqttServerModel;
import com.mobai.mq.rabbitmq.cofig.MqttFactory;
import com.mobai.mq.rabbitmq.cofig.MqttProperties;
import com.mobai.mq.rabbitmq.domian.GetOptions;
import com.mobai.mq.rabbitmq.domian.MqttCallBackServiceImpl;
import com.mobai.openApi.SelectInstances;
import com.mobai.util.RedisService;
import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttConnectOptions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.data.redis.connection.RedisServer;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @ClassName MqttRunner
 * @Description 描述
 * @Author Mobai
 * @Date 2024/6/4 20:03
 */
@Component
public class MqttRunner implements ApplicationRunner {

    @Autowired
    private SelectInstances selectInstances;

    @Autowired
    private RedisService redisService;

    @Override
    public void run(ApplicationArguments args) throws Exception {
        List<String> ips = redisService.getList("mqttIp");
        List<MqttServerModel> list = ips.stream().distinct().map(str -> JSON.parseObject(str, MqttServerModel.class)).toList();
        list.forEach(mqttServerModel -> {

        });
        MqttProperties mqttProperties = MqttProperties.configBuild("39.98.69.92", "topic0");
//        MqttProperties mqttProperties = new MqttProperties();
//          mqttProperties.setBroker("tcp://39.98.69.92:1883");
//          mqttProperties.setTopic("mqtt/test");
        mqttProperties.setUsername("emqx");
        mqttProperties.setPassword("public");
//          mqttProperties.setClientid("subscribe_client");
        int qos = 0;
        try {
            MqttClient client = new MqttFactory(new MqttCallBackServiceImpl()).buildOptions(mqttProperties);
            // 连接参数
            MqttConnectOptions options = GetOptions.getMqttOptionas(mqttProperties);
            // 设置回调
            client.setCallback(new MqttCallBackServiceImpl());
            // 进行连接
            client.connect(options);
            client.subscribe(mqttProperties.getTopic(), qos);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
